from flickerstrip_py.core.pattern_builder import PatternBuilder
from flickerstrip_py.models.pattern import Pattern, PatternData

from . import test_data


def test_from_data():
    meta = Pattern(id=0, name="Cracksauce", flags=0, frames=7, pixels=7, fps=3)
    data = PatternData(data=test_data.CRACKSAUCE_DATA)

    builder = PatternBuilder.from_data(meta, data)
    assert builder.is_valid()


def test_get_frame():
    meta = Pattern(id=0, name="Cracksauce", flags=0, frames=7, pixels=7, fps=3)
    data = PatternData(data=test_data.CRACKSAUCE_DATA)

    builder = PatternBuilder.from_data(meta, data)
    assert builder.get_frame(0) == test_data.CRACKSAUCE_FRAME_0
